//lcd.c
#include <string.h>
#include <iolpc210x.h>
#include "lcd.h"

unsigned long data;
void DelayS (unsigned long a) { while (--a!=0); }

void E_Pulse()
{
  IOSET_bit.P0_22 = 1; //set E to high
  DelayS(10);
  IOCLR_bit.P0_22 = 1; //set E to low
}

void LCDInit()
{
  //first set D4, D5, D6, D7, RS, RW, E to output ports
  IODIR_bit.P0_4 = 1;
  IODIR_bit.P0_5 = 1;
  IODIR_bit.P0_6 = 1;
  IODIR_bit.P0_7 = 1;
  IODIR_bit.P0_22 = 1;
  IODIR_bit.P0_23 = 1;
  IODIR_bit.P0_24 = 1;


  //LCD initialization
  //step by step (from Gosho) - from DATASHEET

  IOCLR_bit.P0_23 = 1;  //set RS port to 0
  IOCLR_bit.P0_24 = 1;  //set R/W port to 0
  IOCLR_bit.P0_22 = 1;  //set E port to 0

  DelayS(110000);        //delay ~110ms

  IOSET_bit.P0_4 = 1;   //set D4 port to 1
  IOSET_bit.P0_5 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  DelayS(10000);         //delay ~10ms


  IOSET_bit.P0_4 = 1;   //set D4 port to 1
  IOSET_bit.P0_5 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  DelayS(10000);         //delay ~10ms


  IOSET_bit.P0_4 = 1;   //set D4 port to 1
  IOSET_bit.P0_5 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  DelayS(10000);         //delay ~10ms

  IOSET_bit.P0_5 = 1;   //set D5 port to 1
  IOCLR_bit.P0_4 = 1;   //set D4 port to 0
  E_Pulse();            //high->low to E port (pulse)

}

void LCDSendCommand(unsigned long a)
{
  IOCLR_bit.P0_24 = 1;                    //set RW port to 0

  DelayS(2000);                            //delay for LCD char ~2ms

  data = 0xffffff0f | a;                  //get high 4 bits
  IOCLR |= 0x000000f0;                    //clear D4-D7
  IOSET = (IOSET | 0x000000f0) & data;    //set D4-D7
  IOCLR_bit.P0_23 = 1;                    //set RS port to 0 -> display set to comand mode
  E_Pulse();                              //pulse to set d4-d7 bits


  data = (a << 4) & 0x000000f0;   	  //get low 4 bits
  IOCLR |= 0x000000f0;                    //clear D4-D7
  IOSET = (IOSET & 0xffffff0f) | data;	  //set D4-D7 (only PORTC4-PORTC7)
  IOCLR_bit.P0_23 = 1;                    //set RS port to 0 -> display set to command mode
  E_Pulse();                              //pulse to set d4-d7 bits

}

void LCDSendChar(unsigned long a)
{
  IOCLR_bit.P0_24 = 1;                    //set RW port to 0

  DelayS(2000);                            //delay for LCD char ~2ms

  data = 0xffffff0f | a;                  //get high 4 bits
  IOCLR |= 0x000000f0;                    //clear D4-D7
  IOSET = (IOSET | 0x000000f0) & data;    //set D4-D7
  IOSET_bit.P0_23 = 1;                    //set RS port to 1 -> display set to data mode
  E_Pulse();                              //pulse to set d4-d7 bits

  data = (a << 4) & 0x000000f0;   	  //get low 4 bits
  IOCLR |= 0x000000f0;                    //clear D4-D7
  IOSET = (IOSET & 0xffffff0f) | data;	  //set D4-D7 (only PORTC4-PORTC7)
  IOSET_bit.P0_23 = 1;                    //set RS port to 1 -> display set to data mode
  E_Pulse();                              //pulse to set d4-d7 bits

}

void LCDSendTxt(char* a)
{
  for(int i=0; i<strlen(a); i++)
  {
    LCDSendChar(a[i]);
  }
}

void SmartUp(void)
{
  for(int i=0; i<40; i++) LCDSendCommand(CUR_RIGHT);
}

void SmartDown(void)
{
  for(int i=0; i<40; i++) LCDSendCommand(CUR_LEFT);
}

